﻿Imports System.ComponentModel

Public Class CaptionUpdater
	Public Shared Function ApplyToDgvs(ParamArray dgvs As DataGridView()) As Integer
		Return (From dgv In dgvs Where TypeOf dgv.DataSource Is BindingSource Let cp = TryCast(dgv.Parent, CaptionPanel) Where cp.NotNull Select New CaptionUpdater(dgv)).Count()
	End Function
	Private _CP As CaptionPanel, _Bs As BindingSource
	Private _Caption0 As String
	Public Sub New(dgv As DataGridView)
		_CP.Be(dgv.Parent)
		_Caption0 = _CP.Text
		_Bs.Be(dgv.DataSource)
		AddHandler _Bs.ListChanged, AddressOf Bs_ListChanged
		BusyDelay.SetCallback(AddressOf SetCaption)
	End Sub
	Private Sub Bs_ListChanged(sender As Object, e As ListChangedEventArgs)
		If e.ListChangedType > ListChangedType.ItemChanged Then Return
		BusyDelay.SetCallback(AddressOf SetCaption)
	End Sub
	Private Sub SetCaption()
		_CP.Text = _Caption0.And(" {", _Bs.Count, "}")
	End Sub
End Class


#If False Then


Public Class CaptionUpdater2

	Public Shared Function ApplyToDgvs(ParamArray dgvs As DataGridView()) As Integer

		Return (From dgv In dgvs Where TypeOf dgv.DataSource Is BindingSource Let cp = dgv.FindAncestor(Of CaptionPanel) Where cp.NotNull Select New CaptionUpdater(dgv, cp)).Count()

	End Function

	Private _CP As CaptionPanel, _Bs As BindingSource

	Private _Caption0 As String

	Public Sub New(dgv As DataGridView, cp As CaptionPanel)

		_CP = cp

		_Caption0 = _CP.Text

		_Bs.Be(dgv.DataSource)

		AddHandler _Bs.ListChanged, AddressOf Bs_ListChanged

	End Sub

	Private Sub Bs_ListChanged(sender As Object, e As ListChangedEventArgs)

		If e.ListChangedType >= ListChangedType.ItemChanged Then Return

		BusyDelay.SetCallback(Sub() _CP.Text = _Caption0.And(" {", _Bs.Count, "}"))

	End Sub

End Class


#End If